<template>
  <div class="home container text-center">
    <h1>
      TodoList
    </h1>
    <div class="">
      <form class="" @submit.prevent="addTodoList(newTodo)">
        <input
          v-model="newTodo"
          type="text"
          class="form-control"
          placeholder="Create a new todo list"
        />
      </form>
    </div>
      <div class="d-flex align-items-center list-group-item" v-for="todo in todos" :key="todo.idList">
    <div class="flex-grow-1 text-center shadow-none">
        <router-link
            :to="{
              name: 'TodoList',
              params: { idList: todo.idList }
            }"
          >
            <span>{{ todo.name }}</span>
          </router-link>
          
        <button @click="deleteTodo(todo)" class="btn btn-outline-danger border-0 ml-2 ">
          <span class="fa fa-trash"></span>
        </button>
        
      </div>
      
    </div>
    
  </div>
</template>

<script>
// @ is an alias to /src
import store from "@/store.js";

export default {
  name: "home",
  components: {},
  data() {
    return {
      newTodo: [],
      todos: fetch("http://localhost:5000/lists", {"Content-Type": "application/json"})
        .then(response => response.json())
        .then(res => this.todos = JSON.parse(JSON.stringify(res)))
      };
  },
  methods: {
    addTodoList(newTodo) {
      if (newTodo.length > 0) {
        const requestOptions = {
          method: "PUT",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({
            name: newTodo,
            created_on: new Date(),
          })
        };
        fetch("http://localhost:5000/lists", requestOptions)
          .then(response => response.json())
          .then(data => this.todos.push(data));
        
      }
    },
    deleteTodo(deletedTodo) {
      const requestOptions = {
          method: "DELETE",
          headers: { "Content-Type": "application/json" }
        };
        fetch("http://localhost:5000/lists/"+deletedTodo.idList+"", requestOptions)
          .then(response => response.json())
          .then(data => {this.todos = JSON.parse(JSON.stringify(data))});
    }
  }
};
</script>
<style scoped>
.home {
  max-width: 1400px;
  margin: 0 auto;
}
img {
  max-width: 200px;
}
a {
  color: lightseagreen;
  text-decoration: none;
}
a:hover,
a:visited {
  text-decoration: underline;
}
</style>
